// LAB:4 To generate basic discrete signal used in Digital Signal Processing

// Version : Scilab 5.4.1
// Operating System : Window-xp, Window-7

clc;
clear;
xdel(winsid());
t=0:0.1:20;
f=0.2;
pi=3.14;

////////////////////////   SINEWAVE   /////////////////
x1=sin(2*pi*f*t);
//scf();
subplot(231);
plot2d3(t,x1);
title('Sinewave','color','red','fontsize', 2);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");

////////////////////////   Cosine Wave   /////////////////
x2=cos(2*pi*f*t);
//scf();
subplot(232);
plot2d3(t,x2);
title('Cosinewave','color','red','fontsize', 2);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");


////////////////////////   Impulse Wave   /////////////////
t1=-10:10;
x3=[zeros(1,10) 1 zeros(1,10)];
//scf();
subplot(233);
plot2d3(t1,x3);
title('Impulse','color','red','fontsize', 2);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");


////////////////////////   Ramp Wave   /////////////////
t4=0:10;
x4=t4;
//scf();
subplot(234);
plot2d3(t4,x4);
title('Ramp Wave','color','red','fontsize',2);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");

////////////////////////   Exponetial Wave   /////////////////
t5=0:10;
x5=exp(t5);
//scf();
subplot(235);
plot2d3(t5,x5);
title('Exponetial Wave','color','red','fontsize',2);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");


////////////////////////   Random Wave   /////////////////

x6=rand(1,100);
//scf();
subplot(236);
plot2d3(1:length(x6),x6);
title('Random Wave','color','red','fontsize',2);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");



/////////////Impulse Sequence  /////////////////
n1=1,n0=50,n2=100;
if((n0<n1)|(n0>n2)|(n1>n2))
    error('arugument incorrect');
end
n=[n1:n2];
x7=[(n-n0)==0,1];
scf()
subplot(221);
plot2d3(n,x7(n1:n2));
title('Impulse Sequence','color','red','fontsize',2);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");


////////////////// Step Sequence  ////////////////
n1=1,n0=50,n2=100;
if((n0<n1)|(n0>n2)|(n1>n2))
    error('arugument incorrect');
end
n=[n1:n2];
x8=[(n-n0)>=0,1];
subplot(222);
plot2d3(n,x8(n1:n2));
title('Step Sequence','color','red','fontsize', 2);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");


////////////////// RECTANGULAR FUNCTION  ////////////////
t=-5:0.1:5
y=[zeros(1,45) ones(1,11) zeros(1,45)]
subplot(223)
plot2d3(t,y)
title('Rectangular Function','color','red','fontsize',2);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");

////////////////// TRIANGULAR FUNCTION  ////////////////
t=0:1:10
y=t;
z=11-t;
b=[y z y z y z];
subplot(224)
plot2d3(b)
title('Triangular Function','color','red','fontsize',2);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");


////////////////// SINC FUNCTION  ////////////////
x=linspace(-10,10,3000);
figure;
plot2d3(x,sinc(x))
title('SINC Function','color','red','fontsize',2);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");
